#include <stdio.h>
#include <stdlib.h>

void swap(short *x, short *y)
{
	int aux = *x;

	*x = *y;
	*y = aux;
}

short *initialpermutation(short l)
{
	short i;
	short *v = malloc(l * sizeof(short));	

	for(i = 0;i < l;i++)
		v[i] = i+1;
	return v;
}

/* trova l'elemento che copre v[i] nell'array v[i+1]...v[l-1] */
short findcover(short *v, short i, short l)
{
	int j,k = -1;

	for(j = i+1; j < l; j++)
		if((v[i] < v[j]) && ((k == -1) || (v[j] < v[k])))
			k = j;
	return k;
}

void sort(short *v, short i, short l)
{
	int j,k;

	for(j = i; j < l-1; j++)
		for(k = j + 1; k < l; k++)
			if(v[k] < v[j])
				swap(v+k,v+j);
}

char nextpermutation(short *v, short l)
{
	short i,j;

	for(i = l-2; i >= 0; i--) {
		if(v[i] < v[i+1]) {
			/* i+1 e' il punto di massimo relativo piu' a destra */
			/* trovo il minimo elemento piu' grande di v[i] in v[i+1]...v[l-1] */
			j = findcover(v,i,l);
			swap(v+i,v+j);
			sort(v,i+1,l);
			return 1;
		}
	}
	return 0;
}

int main(int ac, char **av)
{
	short i;
	short l = atoi(av[1]);
	short *v = initialpermutation(l);

	do {
		for(i = 0;i < l;i++)
			printf("%3d ",v[i]);
		putchar('\n');
	} while(nextpermutation(v,l));

	return 0;
}
